#include "os.h"

int timer_ticks = 0;

/* timer fires 18.222 times per second.*/
void timer_handler(struct regs* r)
{
    /* Increment our 'tick count' */
    ++timer_ticks;

    /* Every 18 clocks (approximately 1 second), we will
    *  display a message on the screen */
    static int z=10;
    if ((timer_ticks % 1093) == 0) // 1093 = 60*18.222
    {
        k_printf("One minute has passed", ++z, 0x0B);
    }
}

void timer_wait(int ticks)
{
    unsigned long eticks;

    eticks = timer_ticks + ticks;
    while(timer_ticks < eticks);
}

void timer_install()
{
    /* Installs 'timer_handler' to IRQ0 */
    irq_install_handler(0, timer_handler);
}
